"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _Utils = _interopRequireDefault(require("./../Combo/Utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  // 显示名称
  getDisplayValue: function getDisplayValue(_ref) {
    var ranges = _ref.ranges,
        type = _ref.type,
        format = _ref.format,
        separator = _ref.separator,
        value = _ref.value;

    if (!Array.isArray(value) || value.length !== 2) {
      return '';
    }

    var start = value[0];
    var end = value[1];

    if (!format) {
      format = _Utils["default"].getFormat(type);
    }

    var displayValue = []; // 显示别名

    if (Object.prototype.toString.call(ranges) === '[object Object]') {
      for (var alias in ranges) {
        var range = ranges[alias];

        if (!Array.isArray(range) || range.length !== 2) {
          continue;
        }

        var rangeStart = range[0];
        var rangeEnd = range[1];

        if (rangeStart instanceof Date === false || rangeEnd instanceof Date === false || start instanceof Date === false || end instanceof Date === false) {
          continue;
        } // 时间相同则显示别名


        if (start.format(format) === rangeStart.format(format) && end.format(format) === rangeEnd.format(format)) {
          return alias;
        }
      }
    } // 显示日期


    if (start instanceof Date) {
      displayValue.push(start.format(format));
    } else {
      displayValue.push('');
    }

    if (end instanceof Date) {
      displayValue.push(end.format(format));
    } else {
      displayValue.push('');
    }

    return displayValue.join(separator || '~');
  }
};
exports["default"] = _default;
module.exports = exports.default;