"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _excluded = ["renderCounter", "percent", "max", "min", "value", "children", "barProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var _default = (0, _react.forwardRef)(function (_ref, ref) {
  var renderCounter = _ref.renderCounter,
      percent = _ref.percent,
      _ref$max = _ref.max,
      max = _ref$max === void 0 ? 100 : _ref$max,
      _ref$min = _ref.min,
      min = _ref$min === void 0 ? 0 : _ref$min,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? 0 : _ref$value,
      children = _ref.children,
      barProps = _ref.barProps,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null); // 节点

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  }); // 计算实际的百分比

  var barPercent = 0;

  if (!isNaN(percent)) {
    barPercent = percent;
  } else if (!isNaN(max) && !isNaN(value)) {
    barPercent = (value - min) / (max - min) * 100;
    console.log('barPercent:', barPercent);
  }

  if (barPercent > 100) {
    barPercent = 100;
  } else if (barPercent < 0) {
    barPercent = 0;
  }

  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: rootRef
  }, others, {
    className: "progress" + (others.className ? ' ' + others.className : '')
  }), /*#__PURE__*/_react["default"].createElement("span", _extends({}, barProps, {
    className: "progress-bar" + ((barProps === null || barProps === void 0 ? void 0 : barProps.className) ? ' ' + barProps.className : ''),
    style: Object.assign({}, (barProps === null || barProps === void 0 ? void 0 : barProps.style) || {}, {
      width: barPercent + '%'
    })
  }), typeof renderCounter === 'function' && renderCounter({
    percent: barPercent
  })), children);
});

exports["default"] = _default;
module.exports = exports.default;